####################################################################################################
## Prepare a deployment, copy defaults if it's a new deployment
####################################################################################################
.trigger_job_commons:
  stage: build
  image: registry.gitlab.com/opencraft/dev/grove/${TOOLS_CONTAINER_IMAGE_NAME}:${TOOLS_CONTAINER_IMAGE_VERSION}
  variables:
    # Thanks to https://gitlab.com/gitlab-org/terraform-images, we only need to set GITLAB_TOFU_STATE_NAME
    # and Terraform will be able to securely store its state in the state store of the current
    # repository, even if it's a private repo.
    GITLAB_TOFU_STATE_NAME: tf-state-${TF_VAR_cluster_provider}
    GITLAB_TOFU_ROOT_DIR: ${CI_PROJECT_DIR}/grove/provider-${TF_VAR_cluster_provider}
    TF_DATA_DIR: ${CI_PROJECT_DIR}/.terraform/
    # Need to set these environment variables to be used in gitlab provider
    # more on https://registry.terraform.io/providers/gitlabhq/gitlab/latest/docs
    TF_VAR_gitlab_project_id: ${CI_PROJECT_ID}
    SCRIPTS_DIR: ${CI_PROJECT_DIR}/grove/tools-container/scripts
  before_script:
    - ${SCRIPTS_DIR}/tf.sh init

prepare deployment:
  extends: .trigger_job_commons
  script:
    - ${SCRIPTS_DIR}/create_merge_request.sh
  only:
    variables:
      - $NEW_INSTANCE_TRIGGER

prepare archive instance:
  extends: .trigger_job_commons
  script:
    - ${SCRIPTS_DIR}/create_merge_request.sh
  only:
    variables:
      - $ARCHIVE_INSTANCE_TRIGGER

prepare delete instance:
  extends: .trigger_job_commons
  script:
    - ${SCRIPTS_DIR}/create_merge_request.sh
  only:
    variables:
      - $DELETE_INSTANCE_TRIGGER

generate batch deployment pipeline:
  extends: .trigger_job_commons
  script:
    - grove webhookpipeline --output trigger_generated.yml
  artifacts:
    paths:
      - trigger_generated.yml
  only:
    variables:
      - $BATCH_DEPLOY_TRIGGER

batch deployment child:
  stage: deploy
  trigger:
    include:
      - artifact: grove/gitlab-ci/trigger_generated.yml
        job: generate batch deployment pipeline
    strategy: depend
  only:
    variables:
      - $BATCH_DEPLOY_TRIGGER


abort deployment:
  extends: .trigger_job_commons
  script: grove abortpipeline
  only:
    variables:
      - $ABORT_DEPLOYMENT_TRIGGER
      - $PIPELINE_ID
